#include "mainwin.h"
#include "libjabber/libEBjabber.h"
#include <commctrl.h>
#include "resource.h"
#include "stun.h"

#define CX_BITMAP     16
#define CY_BITMAP     16
#define NUM_BITMAPS   4
#define TV_TEXT_MAX   256

int g_nOpen, g_nClosed, g_nOnline, g_nNotOnline;
BOOL g_fDragging = FALSE;

extern HINSTANCE HInstance;
extern HWND hWnd;
extern HWND hwndTV;
extern HWND hCMDwnd;
extern Settings ProgramSettings;
extern BOOL OpenVPNStarted;

HTREEITEM AddItemToTree(HWND hwndTV, LPSTR lpszItem, int nLevel, int index);

/****************************************************************************
* 
*    FUNCTION: TV_NotifyHandler(HWND, UINT, UINT, LONG)
*
*    PURPOSE: This function is the handler for the WM_NOTIFY that is 
*    sent to the parent of the tree view window.
*
****************************************************************************/
LRESULT TV_NotifyHandler(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static NM_TREEVIEW *pNm;
	int temp;
	WCHAR buf[TV_TEXT_MAX];
    TVITEM tItem;
	HTREEITEM hTreeItem;
	BYTE cmd;

    int idCtrl = (int)wParam;
    LPNMHDR pnmh = (LPNMHDR)lParam;
//    HRESULT hr;
	UINT uID;
	HMENU hMenu;
	HMENU hMenuRes;
	HTREEITEM htriRes;

    pNm = (NM_TREEVIEW *)lParam;

    // if (wParam != ID_TREEVIEW)
	//	return 0L;

    switch(pNm->hdr.code)
	{
        case NM_RCLICK: // mouse right click
			TVHITTESTINFO tvht;

			ZeroMemory(&tvht, sizeof(TVHITTESTINFO));

            POINT pt;
            GetCursorPos(&pt);

            tvht.pt = pt;
            MapWindowPoints(NULL, pnmh->hwndFrom, &tvht.pt, 1 );
            
            htriRes = TreeView_HitTest(pnmh->hwndFrom, &tvht);

            if (htriRes == NULL)
            {
                // TreeView_HitTest failed
                return 0;
            }

            if (tvht.flags & TVHT_ONITEM)
            {
                // The user clicked on a buddy
                TVITEMEX tvi;
                ZeroMemory(&tvi, sizeof(TVITEM));
    
                tvi.mask = TVIF_TEXT | TVIF_PARAM;
                tvi.hItem = htriRes;
				tvi.pszText = buf;
				tvi.cchTextMax = TV_TEXT_MAX;

                // Get the buddy item
                if (!TreeView_GetItem(hwndTV, &tvi))
                {
                    // TreeView_GetItem failed;
                    return 0;
                }

				TreeView_SelectItem(hwndTV, htriRes);

				if (tvi.lParam != 2)
				{
					// We're on a parent, not a buddy. Return.
					return 0;
				}
                
                // Show the buddy menu
                hMenuRes = LoadMenu( 
                    GetModuleHandle(NULL),
                    MAKEINTRESOURCE(IDR_MENU2));

                hMenu = GetSubMenu(hMenuRes, 0);
				
				if (OpenVPNStarted)
				{
					EnableMenuItem(hMenuRes, ID_STARTOPENVPN, MF_GRAYED);
					EnableMenuItem(hMenuRes, ID_STOPOPENVPN, MF_ENABLED);
				}
				else
				{
					EnableMenuItem(hMenuRes, ID_STARTOPENVPN, MF_ENABLED);
					EnableMenuItem(hMenuRes, ID_STOPOPENVPN, MF_GRAYED);
				}

                // Show the popup menu
                uID = TrackPopupMenu(hMenu,
                    TPM_LEFTALIGN | TPM_RIGHTBUTTON |
                    TPM_NONOTIFY | TPM_RETURNCMD,
                    pt.x, pt.y, 0, hWnd, NULL);
				char *JabUserID = (char *)malloc(MAX_STRING);
				wcstombs(JabUserID, ProgramSettings.UserHandle, 64);
				char *pRes = strchr(JabUserID, '/');
				if (pRes) *(pRes + 1) = 0;
				else strcat_s(JabUserID, MAX_STRING, "/");
				char tempbuf[MAX_STRING];
				wcstombs(tempbuf, buf, MAX_STRING);
				strcat_s(JabUserID, MAX_STRING, tempbuf);
                switch (uID)
                {
                case ID_STOPOPENVPN:
					cmd = DISCONNECT;
					sendChatMessage(&cmd, 1, JabUserID);
					StopOpenVPNConnection();
                    break;

				case ID_STARTOPENVPN:
					InitOpenVPNConnection(JabUserID);
					break;

				case ID_RA:
					//CreateRAServer(JabUserID);
					cmd = STARTRA;
					sendChatMessage(&cmd, 1, JabUserID);
					//StartRA(L"<E><A KH=\"74jXTX5NVpPJyrETJ+k70JP2GV8=\" ID=\"vkZu7ieApLCb52JgKnE1I2SqXzC3ndpEwDJQ8b1kc2JG40PzlpINYZNo5NqVG43P\"/><C><T ID=\"1\" SID=\"2658783926\"><L P=\"49297\" N=\"fe80::d8ff:6cc2:d845:f4ac%10\"/><L P=\"49298\" N=\"fe80::d595:c89f:6288:58db%23\"/><L P=\"49299\" N=\"fe80::44c2:2628:e7c5:af79%24\"/><L P=\"49300\" N=\"fe80::fc4f:8248:af3b:a289%28\"/><L P=\"49301\" N=\"fe80::d18d:b4ae:6e6b:9cbf%33\"/><L P=\"49302\" N=\"10.1.254.189\"/><L P=\"49303\" N=\"192.168.56.1\"/><L P=\"49304\" N=\"192.168.223.6\"/><L P=\"49305\" N=\"192.168.163.1\"/><L P=\"49306\" N=\"192.168.248.1\"/></T></C></E>");

					break;

				case IDC_REMOTE_INSTALL:
					PrintLog(L"Send command INSTALLTAP to %S",JabUserID);
					cmd = INSTALLTAP;
					sendChatMessage(&cmd, 1, JabUserID);
				break;

				case IDC_REMOTE_REMOVE:
					PrintLog(L"Send command UNINSTALLTAP to %S",JabUserID);
					cmd = UNINSTALLTAP;
					sendChatMessage(&cmd, 1, JabUserID);
				break;

				case IDC_REMOTE_EXECUTE:
					PrintLog(L"Send command EXECUTE to %S",JabUserID);
					ExeMessage mess;
					mess.CMDid = EXECUTE;
					mess.HwndID = CreateRemoteCMDDialog(JabUserID);
					if (mess.HwndID != -1) sendChatMessage((BYTE *)&mess, 2, JabUserID);
					return 1;
				break;

				case IDC_RESTART_PROGRAM:
					PrintLog(L"Send command RESTART_PROGRAM to %S",JabUserID);
					cmd = RESTART_PROGRAM;
					sendChatMessage(&cmd, 1, JabUserID);
				break;

				case ID_QUERYPRIVILAGES:
					PrintLog(L"Send command QUERY_PRIVILAGES to %S",JabUserID);
					cmd = QUERY_PRIVILAGES;
					sendChatMessage(&cmd, 1, JabUserID);
				break;

				case IDC_RESTART_WIN:
					PrintLog(L"Send command RESTART_WINDOWS to %S",JabUserID);
					cmd = RESTART_WIN;
					sendChatMessage(&cmd, 1, JabUserID);
				break;

				}
				free(JabUserID);
            }
            return 1;

		case NM_DBLCLK : // Left mouse double click
			// Get the currently selected tree item
			hTreeItem = TreeView_GetSelection(hwndTV);

			tItem.mask = TVIF_TEXT | TVIF_PARAM;
			tItem.hItem = hTreeItem;
			tItem.pszText = buf;
			tItem.cchTextMax = TV_TEXT_MAX;

			// Get the folderId we stored in lparam of selected folder
			TreeView_GetItem(hwndTV, &tItem);
			temp = tItem.lParam;

            return 1;

		default:
			break;
	}
	return 0L;
}

BOOL InitTreeViewImageLists(HWND hwndTV)
{
    HIMAGELIST himl;  // handle to image list
    HBITMAP hbmp;     // handle to bitmap

    // Create the image list.
    if ((himl = ImageList_Create(CX_BITMAP, CY_BITMAP,
        FALSE, NUM_BITMAPS, 0)) == NULL)
        return FALSE;

    // Add the open file, closed file, and document bitmaps.
    hbmp = LoadBitmap(HInstance, MAKEINTRESOURCE(IDB_BITMAP3));
    g_nOpen = ImageList_Add(himl, hbmp, (HBITMAP) NULL);
    DeleteObject(hbmp);

    hbmp = LoadBitmap(HInstance, MAKEINTRESOURCE(IDB_BITMAP3));
    g_nClosed = ImageList_Add(himl, hbmp, (HBITMAP) NULL);
    DeleteObject(hbmp);

    hbmp = LoadBitmap(HInstance, MAKEINTRESOURCE(IDB_BITMAP3));
    g_nOnline = ImageList_Add(himl, hbmp, (HBITMAP) NULL);
    DeleteObject(hbmp);

    hbmp = LoadBitmap(HInstance, MAKEINTRESOURCE(IDB_BITMAP4));
    g_nNotOnline = ImageList_Add(himl, hbmp, (HBITMAP) NULL);
    DeleteObject(hbmp);

    // Fail if not all of the images were added.
    // if (ImageList_GetImageCount(himl) < 3)
    //    return FALSE;

    // Associate the image list with the tree-view control.
    TreeView_SetImageList(hwndTV, himl, TVSIL_NORMAL);

    return TRUE;
}

// AddItemToTree - adds items to a tree-view control.
// Returns the handle to the newly added item.
// hwndTV - handle to the tree-view control.
// lpszItem - text of the item to add.
// nLevel - level at which to add the item.
HTREEITEM AddItemToTree(HWND hwndTV, LPWSTR lpszItem, int nLevel, int index)
{
    TVITEM tvi;
    TVINSERTSTRUCT tvins;
    static HTREEITEM hPrev = (HTREEITEM) TVI_FIRST;
    static HTREEITEM hPrevRootItem = NULL;
    static HTREEITEM hPrevLev2Item = NULL;
    HTREEITEM hti;

    tvi.mask = TVIF_TEXT | TVIF_IMAGE
        | TVIF_SELECTEDIMAGE | TVIF_PARAM;

    // Set the text of the item.
    tvi.pszText = lpszItem;
    tvi.cchTextMax = lstrlen(lpszItem);

    // give it a image.
	if (nLevel == 1)
	{  // parent
		tvi.iImage = g_nOpen; 
		tvi.iSelectedImage = g_nOpen;  
	}
	else if (index == 0)
	{
		tvi.iImage = g_nNotOnline; 
		tvi.iSelectedImage = g_nNotOnline;  
	}
	else
	{
		tvi.iImage = g_nOnline; 
		tvi.iSelectedImage = g_nOnline;  
	}

    // Save the heading level in the item's application-defined
    // data area.
    tvi.lParam = (LPARAM) nLevel;

    tvins.item = tvi;
    tvins.hInsertAfter = hPrev;

    // Set the parent item based on the specified level.
    if (nLevel == 1)
        tvins.hParent = TVI_ROOT;
    else if (nLevel == 2)
        tvins.hParent = hPrevRootItem;
    else
        tvins.hParent = hPrevLev2Item;

    // Add the item to the tree-view control.
    hPrev = (HTREEITEM) SendMessage(hwndTV, TVM_INSERTITEM, 0,
         (LPARAM) (LPTVINSERTSTRUCT) &tvins);

    // Save the handle to the item.
    if (nLevel == 1)
        hPrevRootItem = hPrev;
    else if (nLevel == 2)
        hPrevLev2Item = hPrev;

    // The new item is a child item. Give the parent item a
    // closed folder bitmap to indicate it now has child items.
    if (nLevel > 1) {
        hti = TreeView_GetParent(hwndTV, hPrev);
        tvi.mask = TVIF_IMAGE | TVIF_SELECTEDIMAGE;
        tvi.hItem = hti;
        tvi.iImage = g_nClosed;
        tvi.iSelectedImage = g_nClosed;
        TreeView_SetItem(hwndTV, &tvi);
		TreeView_Expand(hwndTV, hti, TVE_EXPAND); 
    }

    return hPrev;
}

void  DelAllItemsFromTree()
{
	TreeView_DeleteAllItems(GetDlgItem(hWnd, IDC_TREE1));
}

// update the online status of a buddy
void updateBuddyStatus(char *jid, char *status)
{
	WCHAR JID[MAX_STRING];
	mbstowcs(JID, jid, MAX_STRING);
	WCHAR STATUS[MAX_STRING];
	mbstowcs(STATUS, status, MAX_STRING);

	WCHAR buf[TV_TEXT_MAX];
    TVITEM tItem;
	HTREEITEM hTreeItem;
	WCHAR *ptr = NULL;

	// Start searching from the first item, must be a parent
	HWND hwndTreeView = GetDlgItem(hWnd, IDC_TREE1);
	hTreeItem = TreeView_GetFirstVisible(hwndTreeView); 

// find child
//	TreeView_Expand(hwndTreeView, hTreeItem, TVE_EXPAND); 
//	hTreeItem = TreeView_GetChild(hwndTreeView, hTreeItem); 

	while(hTreeItem)
	{
		tItem.mask = TVIF_TEXT | TVIF_IMAGE
						| TVIF_SELECTEDIMAGE | TVIF_PARAM;
		tItem.hItem = hTreeItem;
		tItem.pszText = buf;
		tItem.cchTextMax = TV_TEXT_MAX;

		// Get the folderId we stored in lparam of selected folder
		TreeView_GetItem(hwndTreeView, &tItem);

		if (tItem.lParam == 2)
		{
			// remove <status>
			ptr = wcschr(JID, L'/');
			if (ptr != NULL && !wcscmp(ptr+1, buf)) 
			{
				// match found, update the status
//				strcat(buf, status);
				if (wcsstr(STATUS, L"offline"))
				{
					TreeView_DeleteItem(hwndTreeView, hTreeItem);
				}
				else
				{
					tItem.iImage = g_nOnline; 
					tItem.iSelectedImage = g_nOnline;
					TreeView_SetItem(hwndTreeView, &tItem);
				}
				return;
			}
		}

		// hTreeItem = TreeView_GetNextVisible(hwndTreeView, hTreeItem);
		hTreeItem = TreeView_GetNextSibling(hwndTreeView, hTreeItem);
	}

	// no match found, add it at tree end
	if (ptr == NULL) ptr = wcschr(JID, L'/');
	if (ptr != NULL)wcscpy(buf, ptr + 1);
	else wcscpy(buf, JID);
	if (wcsstr(STATUS, L"offline")) 
		AddItemToTree(hwndTreeView, buf, 2, 0);
	else
		AddItemToTree(hwndTreeView, buf, 2, 1);
}
