/*
 * jabber.c
 *
 * Copyright (C) 2001, Daniel Ding <support@freewebfone.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	This code borrowed heavily from the jabber Linux client EveryBuddy
 *	(http://www.everybuddy.com/)
 */
#include "mainwin.h"
#include<windows.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "libjabber/libEBjabber.h"
#include "stun.h"
#include "resource.h"


//#define IDT_RECONNECT WM_USER + 1106
#define JABBER_POST_MESSAGE   3
#define JABBER_ERROR WM_USER + 1209

BYTE pChatMessage[65536];
char pChatSender[MAX_ADDR];
char userHandle[MAX_STRING];

extern HWND hWnd;
extern NatType stype;
extern StunAddress4 LocalNatPublicSrcAddrAndPort;
extern StunAddress4 stunServerAddr;
extern Settings ProgramSettings;
WCHAR SNatType[9][32] = {L"Unknown",L"Failure",L"Blocked",L"Open",L"Fullcone NAT",
			L"Restricted Cone NAT",L"Port-Restricted Cone NAT",L"Symmetric NAT", L"Firewall"};
extern JABBER_Conn JabberConnection;
extern void updateBuddyStatus(char *name, WCHAR *status);

void jabberDelBuddy(char *data)
{
	JABBER_RemoveContact(&JabberConnection, data);
}

/*
** Name:    jabberAddBuddy
** Purpose: This function is a callback that is called to ensure that
**          we know about our new buddies.
*/
int jabberAddBuddy(struct jabber_buddy *jb)
{
//	updateBuddyStatus(jb->name, status2String(jb->status));
	return TRUE;
}

/*
** Name:    AddContact
** Purpose: Add a contact to roster
*/
int jabberAddContact(char *data)
{
	return JABBER_AddContact(&JabberConnection, data);
}

/*
** Name:     JABBERInstantMessage
** Purporse: This function acts as the gateway between the libjabber and the 
**           gtk interface
** Input:    data    - data needed for instant message
** Output:   none
*/

void JABBERInstantMessage(void *data)
{
    JABBER_InstantMessage_PTR im;
    im = (JABBER_InstantMessage_PTR)data;

	if (hWnd)
	{
		strcpy(pChatSender, im->sender);
		DWORD len = 0;
		PBYTE buf = decrypt_3des(im->msg, &len);
		if(buf > 0)
		{
			memcpy_s(pChatMessage, len, buf, len);
			free(buf);
			PostMessage(hWnd, WM_COMMAND, JABBER_POST_MESSAGE, len);
		}
	}
}

/*
** Name:    JABBERStatusChange
** Purpose: This function is a callback that is called to update the
**          status of a contact in the forward list
** Input:   data - data passed to contact
** Output:  none
*/
void JABBERStatusChange(void *data)
{

    struct jabber_buddy *jb;

    if(!data)
        return;
    jb = (struct jabber_buddy *)data;
	if(strcmp(jb->jid, userHandle)) updateBuddyStatus(jb->jid, status2String(jb->status));
}

void JABBERListDialog(char **list, void *data)
{
    if(!data || !list)
        return;

	JABBERDialog(data);
}

//void JABBERError()

/*
** Name:    JABBERDialog
** Purpose: This function is a callback that is called to ask for authorization
** Input:   data - data passed to contact
** Output:  none
*/
void JABBERDialog(void *data)
{
    JABBER_Dialog_PTR jd;
	//HWND hwnd;

    if(!data)
        return;
    jd = (JABBER_Dialog_PTR)data;
	//hwnd = GetActiveWindow();
	PrintLog(L"Error: %S. %S", jd->heading, jd->message);
    //MessageBox (hwnd, jd->message, jd->heading, MB_OK) ;
              
    return;
}

int GetJabberConnState()
{
	if(JabberConnection.conn) return JabberConnection.conn->state;
	return 0;
}

/*
** Name:    JABBERLogout
** Purpose: This function is called when a user is logged out automatically
**          by the server
** Input:   data - date to be passed
** Output:  none
*/
void logoutJabber()
{
	PrintLog(L"Logout");
	DelAllItemsFromTree();
	if (GetJabberConnState() != JCONN_STATE_OFF)
	{   
		
		if(JabberConnection.conn) shutdown(JabberConnection.conn->fd , 2);
		//JABBER_Logout();
	}
	//CloseHandle (logout_event);
	//Reconnect(5000);
	SendStatusInfo(0);
}

// display the error message 
void JABBERError(char *message)
{
	SendMessage(hWnd, WM_COMMAND, JABBER_ERROR, (LPARAM)message);
}

// display the subscribe request message
// if user grant the request, send back another subscribe
// request and add the buddy in the roster 
void subscribeRequest(JABBER_Dialog *JD)
{
/*	HWND hwnd;

	hwnd = GetActiveWindow();
	if (MessageBox(hwnd, JD->message, JD->heading, MB_YESNO) == IDYES) 
		j_allow_subscribe(JD);
	// add the buddy to the roster tree
	updateBuddyStatus(JD->requestor, "<offline>");
*/}

// display the unsubscribe request message
// if user grant the request, send back another unsubscribe
// request and add the buddy in the roster 
void unsubscribeRequest(JABBER_Dialog *JD)
{
	//HWND hwnd;

	//hwnd = GetActiveWindow();
	// if (MessageBox(hwnd, JD->message, JD->heading, MB_YESNO) == IDYES) 
	//MessageBox(hwnd, JD->message, JD->heading, MB_OK); 
	j_unsubscribe(JD);
	// remove the buddy from the roster tree
//	deleteBuddy(JD->requestor);
}

// Thread that receive data from Jabber server
void rcvJabberServerData(JABBER_Conn *data)
{
    JABBER_Conn *JConn=data;
	while (GetJabberConnState()!=JCONN_STATE_OFF && JConn->conn->fd!=-1)
	{
		// Let libjabber do the work, it calls what we setup in jab_packet_handler 
		if(jab_poll(JConn->conn, 8000000) == -1) break;
	}
	JABBER_Logout();
}

// create a receive thread to read data from server
BOOL createJabberRcvThread(void *data)
{
   HANDLE hJabberRcvThread;
   DWORD dwJabberRcvThreadID;
   
   // Create a thread to receive IGMP Query packets
   hJabberRcvThread = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)rcvJabberServerData, 
                                 &JabberConnection, 0, &dwJabberRcvThreadID);
   if (!hJabberRcvThread) {
      // printf ("Unable to create Jabber client thread\n");
      return FALSE;
   }

   return TRUE;
}

void loginJabber()
{
	stunServerAddr.addr=0;
	char AddrBuf[MAX_ADDR];
//	char UserBuf[MAX_ADDR];
	char PassBuf[MAX_ADDR];

	wcstombs(AddrBuf, ProgramSettings.StunAddr, MAX_ADDR);
	if(!stunParseServerName( AddrBuf, stunServerAddr))
	{
		PrintLog(L"Error resolve STUN-address");
		return;
	}
	bool presPort=false;
	bool hairpin=false;
	LocalNatPublicSrcAddrAndPort.addr = 0;
	LocalNatPublicSrcAddrAndPort.port = 0;
	stype = stunNatType(
		stunServerAddr,
		false,
		&presPort,
		&hairpin,
		0,
		&LocalNatPublicSrcAddrAndPort);

	PrintLog(L"Type of NAT: %s.", SNatType[stype]);
	PostMessage(hWnd, UPDATE_INFO, NAT_TYPE, (LPARAM)&SNatType[stype]);

	if (stype > StunTypeBlocked) 
	{
		PostMessage(hWnd, UPDATE_INFO, PUBLIC_IP, (LPARAM)LocalNatPublicSrcAddrAndPort.addr);
		if (!wcschr(ProgramSettings.UserHandle, L'/'))
		{
			IN_ADDR Addrs;
			Addrs.s_addr = htonl(LocalNatPublicSrcAddrAndPort.addr);
			char Cname[MAX_COMPUTERNAME_LENGTH+1];
			DWORD sizeCname = sizeof(Cname);
			GetComputerNameA(Cname, &sizeCname);
//			wcstombs(UserBuf, ProgramSettings.UserHandle, MAX_ADDR);
			sprintf_s(userHandle, MAX_STRING, "%S/%s-%s",
				ProgramSettings.UserHandle, inet_ntoa(Addrs), Cname);	
			PrintLog(L"UserId: %S", userHandle);
		}
		else wcstombs(userHandle, ProgramSettings.UserHandle, 64);

		wcstombs(PassBuf, ProgramSettings.Pass, MAX_ADDR);
		PostMessage(hWnd, UPDATE_INFO, JABBER_STATUS, 1);

		JABBER_Login(userHandle, PassBuf, false);

		if (GetJabberConnState() == JCONN_STATE_ON)
		{
			if(hWnd) SetWindowTextA(hWnd, userHandle);
			sendStateOnline();
			refreshRoster();
			PrintLog(L"Jabber connection established");
		}
	}
}

void sendChatMessage(BYTE *msg, DWORD dwSz, char *buddy)
{
	char *letter = crypt_3des(msg, dwSz);
	if(GetJabberConnState() != JCONN_STATE_OFF)
		JABBER_SendMessage(&JabberConnection, buddy, letter);
	if(letter) free(letter);
}

char *status2String(int status)
{
	switch (status) {
	
	case JABBER_ONLINE:
		return "<online>";
	case JABBER_AWAY:
		return "<away>";
	case JABBER_DND:
		return "<dnd>";
	case JABBER_XA:
		return "<xa>";
	case JABBER_CHAT:
		return "<chat>";
	case JABBER_OFFLINE:
		return "<offline>";
	default:
		return "<unknown>";
	}

}

// change state to "online" 
void sendStateOnline()
{
	JABBER_ChangeState(&JabberConnection, JABBER_ONLINE);
}

// change state to "online" 
void sendStateAway()
{
	JABBER_ChangeState(&JabberConnection, JABBER_AWAY);
}


// Request roster update 
void refreshRoster()
{
//	DelAllItemsFromTree();

	xmlnode x;

	x = jutil_iqnew (JPACKET__GET, NS_ROSTER);
	jab_send (JabberConnection.conn, x);
}

void testPresence()
{
//	BYTE cmd = TEST;
//	sendChatMessage(&cmd, 1, userHandle);
	
	xmlnode x;
	x = jutil_presnew (JPACKET__UNKNOWN, NULL, NULL);
	jab_send (JabberConnection.conn, x);
}

void Reconnect(int ms)
{
	SetTimer(hWnd, IDT_RECONNECT, ms, (TIMERPROC)NULL);
}

void SendStatusInfo(int stat)
{
	PostMessage(hWnd, UPDATE_INFO, JABBER_STATUS, stat);
}