/*------------------------
   SMALLJAB.H header file
  ------------------------*/
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <winsock2.h>
#include <Wincrypt.h>

//C++ file library header
#include <iostream>
#include <fstream>

#define IDT_REFRESH_CONNECTION WM_USER + 1102
#define IDT_SEND_FIRST_MESS WM_USER + 1103
#define IDT_SEND_PACKET WM_USER + 1104
#define IDT_RECV_TIMEOUT WM_USER + 1105
#define IDT_RECONNECT WM_USER + 1106
#define IDT_RECONNECT2 WM_USER + 1109
#define ID_TRAY WM_USER+1108

#define MAX_LENGTH	256		//max length for a line 
#define WSA_NETEVENT   WM_USER + 100
#define WSA_MANAGE_EVENT   WM_USER + 99
#define DESIRED_WINSOCK_VERSION 0x0101  // winsock ver 1.1...
#define MINIMUM_WINSOCK_VERSION 0x0001  // ver 1.0
#define JABBER_POST_MESSAGE   3
#define MAX_STRING 256
#define MAX_ADDR 64
#define JABBER_ERROR WM_USER + 1209
#define UPDATE_INFO WM_USER + 2209
#define MESSAGE_NOTIFY WM_USER + 10001

typedef struct
{
	WCHAR OpenVPNStartString[1024];
	int mode;
	WCHAR jabberServer[MAX_ADDR];
	int jabberPort;
	WCHAR UserHandle[MAX_ADDR];
	WCHAR Pass[MAX_STRING];
	WCHAR CMDPass[MAX_STRING];
	WCHAR StunAddr[MAX_ADDR];
	WCHAR PathToFiles[MAX_STRING];
	BOOL DisableSleep;
	int OpenVPNPort;
	int jabberUpdateTime;
	char LTunIP[MAX_ADDR];
} Settings;

typedef struct
{
	unsigned char CMDid;
	char mess[MAX_STRING];
} ErrMessage;


typedef struct
{
	unsigned char CMDid;
	ULONG addr;
	unsigned short port;
} AddrMessage;

typedef struct
{
	unsigned char CMDid;
	unsigned char HwndID;
	unsigned char ThreadID;
	char exeMess[16384];
} ExeMessage;

typedef struct
{
	HWND hwnd;
	unsigned char ThreadID;
	char sender[MAX_ADDR];
} CHCMDwnd;

typedef struct
{
	char sender[MAX_ADDR];
	unsigned char WindowID;
	WCHAR exe_path[MAX_PATH];
	WCHAR command_line[256];
} CommandStruct;

typedef enum 
{
	STARTCONNECTFixedPort = 1,
	STARTCONNECTRundomPort,
	STARTCONNECTFixedPorts,
	STARTCONNECTRundomPorts,
	CONNECTFixedPort,
	CONNECTRundomPort,
	CONNECTFixedPorts,
	CONNECTRundomPorts,
	DISCONNECT,
	INSTALLTAP,
	UNINSTALLTAP,
	TEST,
	RECEIVED,
	EXECUTE,
	INPUTMESS,
	STOPEXECUTE,
	LOG,
	ENDLOG,
	RESTART_PROGRAM,
	RESTART_WIN,
	STARTNEWSESSION,
	STARTRA,
	RAINVITESTRING,
	STOPRA,
	QUERY_PRIVILAGES,
	ERROR_MESSAGE
}CmdId;

typedef enum 
{
	NAT_TYPE,
	PUBLIC_IP,
	JABBER_STATUS,
	OPENVPN_STATUS,
	TUNNEL_IP
};

typedef struct
{
  WCHAR    *PortPath;
  WCHAR    *PortFriendlyName;
} SERIAL_PORT,*LPSERIAL_PORT;
 
bool InitOpenVPNConnection(char * JabUserID);
bool StartConnection(int Typ);
void SendPackets();
void StopHoleAtempt();
void StopOpenVPNConnection();
void StartOpenVPN();
void startexe(CommandStruct * Cstruct);
HANDLE StartProgram(WCHAR *exe_path, WCHAR *command_line, BOOL SetPrivs);
bool StartRA(WCHAR *Ticket);
bool StartRAClient(WCHAR *Ticket);
void StopRAClient();
void StopRAServer();
bool CreateRAServer(char *JabUserID);
BOOL CALLBACK WndRAProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL IsWow64();
void TAPInstall(bool TypeOperation);
void StartTAPInstall(LPVOID TypeOperation);
void initClient(HWND hwnd);
unsigned char  CreateRemoteCMDDialog(char *sender);
void PrintLog(const WCHAR * szFormat, ...);
BOOL CALLBACK WndTabProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL OnCommand(HWND hwnd, WPARAM wParam, LPARAM lParam);
BOOL OnUpadateInfo(HWND hwnd, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK WndClientProc (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK WndCMDProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WndServerProc (HWND, UINT, WPARAM, LPARAM);
int ReadSettings();
int WriteSettings();
void WINAPI ServiceMain(DWORD argc, LPSTR* argv);
void StopService();
void WINAPI ServiceControl(DWORD dwControlCode);
void SetServiceStatus(DWORD dwCurrentState,
                           DWORD dwWin32ExitCode,
                           DWORD dwWaitHint);
BOOL InitServiceData();
void WINAPI ServiceMain(DWORD argc, LPSTR* argv);
void GetSvcError();
HRESULT RemoveSevice();
HRESULT InstallService();
void CryptCleanUp(void);
BOOL CryptInit();
BOOL OnJabberCommand(HWND hwnd, WPARAM wParam, LPARAM lParam);
char *crypt_3des(BYTE *buf, DWORD dwSz);
BYTE *decrypt_3des(char *letter, DWORD *dwSz);
void updateBuddyStatus(char *jid, char *status);
void DelAllItemsFromTree();

LRESULT OnRightTrayClick();
BOOL CALLBACK WndSettingsProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL InitTreeViewImageLists(HWND hwndTV);

LRESULT TV_NotifyHandler(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
