#include "mainwin.h"
#include "libjabber/libEBjabber.h"
//#include "rdp/func.h"
#include "rdp/rdp.h"
#include "rdp/ax.h"
#include "resource.h"

RAS::SERVER * Serv = NULL;
extern HINSTANCE HInstance;
extern HWND hWnd;
HWND hWndRA = NULL;
HWND hWndRAInput = NULL;
RAS::CLIENT * pClient = NULL;
extern HINSTANCE HInstance;
WCHAR * pTickt;

BOOL CALLBACK WndRAProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_SIZE:
		{
			RECT re = {0};
			GetClientRect(hwnd, &re);
			SetWindowPos(hWndRA, 0, 0, 0, re.right,re.bottom, SWP_SHOWWINDOW);
			return 0;
		}
		break;

		case MESSAGE_NOTIFY:
		{
			if (DISPID_RDPSRAPI_EVENT_ON_ATTENDEE_CONNECTED == wParam)
			{
				//pClient->RequestControl(CTRL_LEVEL_VIEW);
				pClient->RequestControl(CTRL_LEVEL_INTERACTIVE);
				pClient->SmartResize(true);
			
				//   
				hWndRAInput = hWndRA;
				for(int i = 0; i < 5; i++)	hWndRAInput = FindWindowEx(hWndRAInput, NULL, NULL, NULL);
				hWndRAInput = FindWindowEx(hWndRAInput, NULL, L"IHWindowClass", NULL);
			}
			return 0;
		}
		break;

		case WM_ACTIVATE:
			if(pClient && wParam != WA_INACTIVE)
				SetFocus(hWndRAInput);
			return 0;
		break;

		case WM_CLOSE:
		{
			StopRAClient();
			DestroyWindow(hwnd);
			return 0;
		}
		break;

		case WM_DESTROY:
		{
			PostQuitMessage(0);
			return 0;
		} 
	}
	return DefWindowProc(hwnd, message, wParam, lParam);
}

bool StartRAClient(WCHAR *Ticket)
{
	if (pClient) return false;
	PrintLog(L"Starting Remote Assistance client");
	int len = wcslen(Ticket);
	pTickt = (WCHAR *)malloc(2*(len + 1));
	wcscpy(pTickt, Ticket);
	if (!CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)StartRA, pTickt, 0, NULL))
	{
		PrintLog(L"Start RA client failure");
		return false;
	}
	return true;
}

bool StartRA(WCHAR *Ticket)
{
	CoInitializeEx(0, COINIT_APARTMENTTHREADED);
	AXRegister();

	WNDCLASS wc;
	wc.style=0;
	wc.lpfnWndProc = (WNDPROC)WndRAProc;
	wc.cbClsExtra=wc.cbWndExtra=0;
	wc.hInstance=HInstance;
	wc.hIcon=NULL;
	wc.hCursor=NULL;
	wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName=NULL;
	wc.lpszClassName=L"RAWindow";
	if (!RegisterClass(&wc)) return FALSE;

	 /*       */
	HWND hWndClient = CreateWindow(L"RAWindow", L"Remote Assistance", WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT ,NULL, NULL, HInstance, NULL);
	if (!hWndClient) return FALSE;
	ShowWindow(hWndClient, SW_SHOW);
	UpdateWindow(hWndClient);

	hWndRA = CreateWindowEx(0, L"AX" ,L"{32be5ed2-5c86-480f-a914-0ff8885a1b3f}", WS_CHILD | WS_VISIBLE, 0, 0, 1, 1, hWndClient, (HMENU)hWndRA, HInstance, 0);
	if (hWndRA)
	{
		IUnknown*a = 0;
		SendMessage(hWndRA, AX_QUERYINTERFACE, (WPARAM)&__uuidof(IUnknown*), (LPARAM)&a);
		pClient = new RAS::CLIENT(a);
	}
	else
	{
		pClient = new RAS::CLIENT;
		// use } instead of { to force AX to create it with AX_RECREATE
		hWndRA = CreateWindowEx(0, L"AX", L"}32BE5ED2-5C86-480F-A914-0FF8885A1B3F}", WS_CHILD | WS_VISIBLE, 0, 0, 1, 1, hWndClient, (HMENU)hWndRA, HInstance, 0);
		SendMessage(hWndRA, AX_RECREATE, 0, (LPARAM)pClient->GetInterface());
	}
	SendMessage(hWndRA, AX_INPLACE, 1, 0);

	pClient->SetWindowNotification(hWndClient, MESSAGE_NOTIFY);
	pClient->CreateVirtualChannel(L"test", true, CHANNEL_PRIORITY_MED);
	pClient->Connect(Ticket, L"A Client", L"");
	SendMessage(hWndClient, WM_SIZE ,0, 0);


	MSG msg; /*    */
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg); 
		DispatchMessage(&msg); 
	} 
	UnregisterClass(L"RAWindow", HInstance);
	free(pTickt);
	return msg.wParam; 
}

void StopRAClient()
{
	BYTE cmd = STOPRA;
//	sendChatMessage(&cmd, 1, JabUserID);
	DestroyWindow(hWndRA);
	if (pClient)
	{
		delete pClient;
		pClient = NULL;
	}
}

bool CreateRAServer(char *JabUserID)
{
	PrintLog(L"Creating Remote Assistance server");
	StopRAServer();
	Serv = new RAS::SERVER;
	int ty = 0,po = 0,col = 16;
	bool dy = 0;

	Serv->CreateVirtualChannel(L"test",true,CHANNEL_PRIORITY_MED);
	Serv->Open();
	Serv->SetWindowNotification(hWnd, MESSAGE_NOTIFY);
	RAS::S_INVITATION* inv = Serv->Invite(0, L"", L"group", 3);
	if (inv)
	{
		int len = inv->GetTicket().length();
		byte * InviteMessage = (byte *)malloc(2*len + 1);
		*InviteMessage = RAINVITESTRING;
		memcpy(InviteMessage + 1, inv->GetTicket().c_str(), 2*len);
		sendChatMessage(InviteMessage, 2*len + 1, JabUserID);
	}
	else
	{
		PrintLog(L"Error when create invite-string");
		return false;
	}
	return true;
}

void StopRAServer()
{
	if(Serv)
	{
		delete Serv;
		Serv = NULL;
	}
}

