//
#ifndef _W_CLASS
#define _W_CLASS
class W
  {
  private:

    char mempty[5];
    wchar_t wempty[5];

    char * MS;
    wchar_t * WS;
    BSTR OS;
    int s;

  public:

    W(const char*);
    W(const wchar_t*);
    ~W();
    const TCHAR* t();
    const char* m();
    const wchar_t* w();
    const char* me();
    const wchar_t* we();
    operator const char*();
    operator const wchar_t*();
    operator char*();
    operator wchar_t*();
    const BSTR o();
  };
#endif


// W class
W::W(const char *a)
{
   MS = 0;
   WS = 0;
   OS = 0;
   strcpy(mempty, "");
   lstrcpyW(wempty, L"");
   if (!a)
      return;
   if (strcmp(a, "") == 0)
      return;
   s = strlen(a);
   MS = new char[s + 10];
   strcpy(MS, a);
   WS = new wchar_t[(s + 10) * 2];
   MultiByteToWideChar(CP_UTF8, 0, MS, -1, WS, (s + 10) * 2);
   OS = SysAllocString(WS);
}

W::W(const wchar_t * a)
{
   MS = 0;
   WS = 0;
   OS = 0;
   if (!a)
      return;
   if (lstrcmpW(a, L"") == 0)
      return;
   s = lstrlenW(a);
   WS = new wchar_t[s + 10];
   lstrcpyW(WS, a);
   MS = new char[(s + 10) * 2];
   WideCharToMultiByte(CP_UTF8, 0, WS, -1, MS, (s + 10) * 2, 0, 0);
   OS = SysAllocString(WS);
}

W::~W()
{
   if (MS)
      delete[]MS;
   if (WS)
      delete[]WS;
   if (OS)
      SysFreeString(OS);
}
const char *W::m()
{
   return (const char *)MS;
}
const wchar_t *W::w()
{
   return (const wchar_t *)WS;
}
const TCHAR *W::t()
{
#ifdef _UNICODE
   return (const wchar_t *)WS;
#else
   return (const char *)MS;
#endif
}
const char *W::me()
{
   if (!MS)
      return (const char *)mempty;
   return (const char *)MS;
}
const wchar_t *W::we()
{
   if (!WS)
      return (const wchar_t *)wempty;
   return (const wchar_t *)WS;
}
const BSTR W::o()
{
   return (const BSTR)OS;
}
W::operator  const char *()
{
   return me();
}
W::operator  const wchar_t *()
{
   return we();
}
W::operator  char *()
{
   return (char *)me();
}

W::operator  wchar_t * ()
{
   return (wchar_t *) we();
}

#define MATCH_TRUE 1
#define MATCH_FALSE 0
#define MATCH_ABORT -1

#define NEGATE_CLASS
#define OPTIMIZE_JUST_STAR
#undef MATCH_TAR_PATTERN


// OPTI

char DMtable[256] = {0};
void PrepareDoMatchTable()
	{
	for (int i=0; i < 256; ++i)
     	DMtable[i]=toupper(static_cast<char>(i));
   }

int DoMatch(char *text, char *p, bool IsCaseSensitive = false)
{
   // probably the MOST DIFFICULT FUNCTION in TurboIRC
   // Thanks to BitchX for copying this function
   //int last;
   int matched;
   //int reverse;
   int pT = 0;
   int pP = 0;

   for (; p[pP] != '\0'; pP++, pT++)
   {
      if (text[pT] == '\0' && p[pP] != '*')
         return MATCH_ABORT;
      switch (p[pP])
      {
//         case '\\': // Match with following char
//                pP++;
         // NO BREAK HERE

      default:
         if (IsCaseSensitive)
         {
            if (text[pT] != p[pP])
               return MATCH_FALSE;
            else
               continue;
         }
//         if (toupper(text[pT]) != toupper(p[pP]))
         if (DMtable[text[pT]] != DMtable[p[pP]])
            return MATCH_FALSE;
         continue;

      case '?':
         continue;

      case '*':
         if (p[pP] == '*')
            pP++;
         if (p[pP] == '\0')
            return MATCH_TRUE;
         while (text[pT])
         {
            matched = DoMatch(text + pT++, p + pP);
            if (matched != MATCH_FALSE)
               return matched;
         }
         return MATCH_ABORT;

      }
   }
#ifdef MATCH_TAR_PATTERN
   if (text[pT] == '/')
      return MATCH_TRUE;
#endif
   return (text[pT] == '\0');
}



// This will be called from the other funcs
int VMatching(char *text, char *p, bool IsCaseSensitive = false)
{
#ifdef OPTIMIZE_JUST_STAR
   if (p[0] == '*' && p[1] == '\0')
      return MATCH_TRUE;
#endif
   return (DoMatch(text, p, IsCaseSensitive) == MATCH_TRUE);
}





/*
void Update()
	{
	if (TU_QuickUpdate(ttitle,L"{}") == 99)
		SendMessage(MainWindow,WM_CLOSE,-1,-1);
	}

*/
struct ASKTEXT
   {
   TCHAR* ti;
   TCHAR* as;
   TCHAR* re;
   };


INT_PTR CALLBACK A_DP(HWND hh,UINT mm,WPARAM ww,LPARAM ll)
   {
   static ASKTEXT* as = 0;
   switch(mm)
      {
      case WM_INITDIALOG:
         {
         as = (ASKTEXT*)ll;
         SetWindowText(hh,as->ti);
         SetWindowText(GetDlgItem(hh,101),as->as);
         SetWindowText(GetDlgItem(hh,102),as->re);
         return true;
         }
      case WM_COMMAND:
         {
         if (LOWORD(ww) == IDOK)
            {
            GetWindowText(GetDlgItem(hh,102),as->re,1000);
            EndDialog(hh,IDOK);
            return 0;
            }
         if (LOWORD(ww) == IDCANCEL)
            {
            EndDialog(hh,IDCANCEL);
            return 0;
            }
         }
      }
   return 0;
   }

bool AskText(HWND hh,TCHAR* ti,TCHAR* as,TCHAR* re)
   {
   ASKTEXT a = {ti,as,re};
   return (DialogBoxParam(GetModuleHandle(0),_T("AT_DIALOG_EN"),hh,A_DP,(LPARAM)&a) == IDOK);
   }

// Quick Clipboard Stuff
void SetClip(const wchar_t* x)
	{
	OpenClipboard(0);
	EmptyClipboard();
	HGLOBAL hGlobal = GlobalAlloc(GMEM_ZEROINIT, (wcslen(x) + 100)*sizeof(TCHAR));
	wchar_t* a = (wchar_t*)GlobalLock(hGlobal);
	wcscpy(a,x);
	GlobalUnlock(hGlobal);
	SetClipboardData(CF_UNICODETEXT,hGlobal);
	MessageBox(0,L"String copied",L"Server",MB_OK);
	CloseClipboard();
	}

wstring GetClip()
{
	TCHAR Ticket[10000] = {0};
	OpenClipboard(0);
	HANDLE h;
	h = GetClipboardData(CF_UNICODETEXT);
	size_t s = GlobalSize(h);
	if (s)
	{
		void* pp = GlobalLock(h);
		memcpy(Ticket,pp,s);
		GlobalUnlock(h);
	}
	CloseClipboard();
	wstring x = Ticket;
	return x;
}

