#include "mainwin.h"
#include "libjabber/libEBjabber.h"
#include "stun.h"
#include "udp.h"
#include "resource.h"
#include "elevation.h"
#include <shellapi.h>


extern int fd;
extern Settings ProgramSettings;
extern SOCKADDR_IN DestNatPublicAddrAndPort;
extern int LocalPort;
extern CHCMDwnd ChCMDwnd[64];
extern HINSTANCE HInstance;
extern HWND hWnd;

BOOL ProcessTAPInstall = false;
BOOL OpenVPNStarted = false;
BOOL TunnelStarted = false;
HANDLE g_hChildStd_IN_Wr[64];
HANDLE exit_event = NULL;
WCHAR IPstring[MAX_ADDR];

void StartOpenVPN()
{
//  openvpn
	PostMessage(hWnd, UPDATE_INFO, OPENVPN_STATUS, 3);
	WCHAR exe_path[MAX_PATH];
	WCHAR command_line[256];
	PrintLog(L"Starting OpenVPN");
	DWORD priority;
	priority = NORMAL_PRIORITY_CLASS;
	STARTUPINFO start_info;
	PROCESS_INFORMATION proc_info;

	HANDLE g_hChild_OUT_Rd = NULL;
	HANDLE g_hChild_OUT_Wr = NULL;

	SECURITY_ATTRIBUTES saAttr; 
	memset(&saAttr, 0, sizeof(saAttr));
	SECURITY_DESCRIPTOR sd;
	memset(&sd, 0, sizeof(sd));
	saAttr.nLength = sizeof (SECURITY_ATTRIBUTES);
	saAttr.lpSecurityDescriptor = &sd;
	saAttr.bInheritHandle = TRUE;
	if (!InitializeSecurityDescriptor (saAttr.lpSecurityDescriptor, SECURITY_DESCRIPTOR_REVISION)) return;
	if (!SetSecurityDescriptorDacl (saAttr.lpSecurityDescriptor, TRUE, NULL, FALSE)) return;
	if ( ! CreatePipe(&g_hChild_OUT_Rd, &g_hChild_OUT_Wr, &saAttr, 0) )
	{
		PrintLog(L"Error CreatePipe"); 
		return;
	}
	// Ensure the read handle to the pipe for STDOUT is not inherited.
	if ( ! SetHandleInformation(g_hChild_OUT_Rd, HANDLE_FLAG_INHERIT, 0) )
		PrintLog(L"Stdout SetHandleInformation"); 

	ResetEvent(exit_event);
	OpenVPNStarted = true;
	memset(&start_info,0,sizeof(start_info));
	memset(&proc_info,0,sizeof(proc_info));

	GetStartupInfo(&start_info);
	start_info.cb = sizeof(start_info);
	start_info.lpTitle = L"jpOpenVPN";
	start_info.dwFlags = STARTF_USESTDHANDLES|STARTF_USESHOWWINDOW;
	start_info.wShowWindow = SW_HIDE;
	start_info.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
	start_info.hStdOutput = start_info.hStdError = g_hChild_OUT_Wr;

	if(fd)
	{
		closesocket(fd);
		fd = 0;
		Sleep(500);
	}


	//exit_event = CreateEventA(NULL, FALSE, FALSE, "exit-event");
	swprintf_s(exe_path, MAX_PATH, L"%sbin\\openvpn.exe", ProgramSettings.PathToFiles);
	swprintf_s(command_line, 256,
		L" --remote %S --lport %u --rport %u --service exit-event 1  --ifconfig %s %s",
		inet_ntoa(DestNatPublicAddrAndPort.sin_addr),
		LocalPort,
		htons(DestNatPublicAddrAndPort.sin_port),
		IPstring,
		ProgramSettings.OpenVPNStartString);

	if (!CreateProcess(exe_path,
	     command_line,
	     NULL,
	     NULL,
	     TRUE,
	     priority | CREATE_NEW_CONSOLE,
	     NULL,
	     ProgramSettings.PathToFiles,
	     &start_info,
	     &proc_info))
	{
		PrintLog(L"Start OpenVPN failed. Path: %s. Commands: %s. Error: %d", exe_path, command_line, GetLastError());
		CloseHandle(g_hChild_OUT_Wr);
		CloseHandle(g_hChild_OUT_Rd);
		StopOpenVPNConnection();
		return;
	}

	CloseHandle(g_hChild_OUT_Wr);

	DWORD dwRead, readed;
	BOOL bSuccess = FALSE;
	CHAR chBuf[4096];
	int begin = 0;
	int temp;
	do
	{
		begin = GetTickCount();
		dwRead = 0;
		readed = 0;
		//   
		bSuccess = ReadFile( g_hChild_OUT_Rd, &chBuf[readed], 4095 - readed, &dwRead, NULL);
		if(!bSuccess) break;
		readed = readed + dwRead;
		do //      500
		{
			bSuccess = PeekNamedPipe(g_hChild_OUT_Rd, NULL, NULL, NULL, &dwRead, NULL);
			if (bSuccess && dwRead)
			{
				bSuccess = ReadFile( g_hChild_OUT_Rd, &chBuf[readed], 4095 - readed, &dwRead, NULL);
				readed = readed + dwRead;
			}
			Sleep(10);
			temp = GetTickCount();
		}
		while (bSuccess && (readed < 4095) && ((GetTickCount() - begin) < 500));
		if(readed > 0)
		{
			chBuf[readed] = 0;
			PrintLog(L"OpenVPN:\r\n%S", chBuf);
			if(strstr(chBuf, "Initialization Sequence Completed"))
				PostMessage(hWnd, UPDATE_INFO, OPENVPN_STATUS, 4);
		}
	}
	while (WaitForSingleObject(exit_event, 0) == WAIT_TIMEOUT && bSuccess);
	CloseHandle(g_hChild_OUT_Rd);
	SetEvent(exit_event);
	OpenVPNStarted = false;
	PostMessage(hWnd, UPDATE_INFO, OPENVPN_STATUS, 0);
	PrintLog(L"OpenVPN Stopped");
}

void startexe(CommandStruct * Cstruct)
{ 
	HANDLE g_hChildStd_IN_Rd = NULL;
	HANDLE g_hChildStd_OUT_Rd = NULL;
	HANDLE g_hChildStd_OUT_Wr = NULL;
	ExeMessage string;
	string.CMDid = LOG;
	string.HwndID = Cstruct->WindowID;

// Find empty place for handle

	unsigned char i =0;
	while (i != 64 && g_hChildStd_IN_Wr[i] != NULL) i++;
	if (i == 64 )
	{
		PrintLog(L" Maximum threads");
		return;
	}
	string.ThreadID = i;
	sendChatMessage((BYTE *)&string, 3, Cstruct->sender);


	SECURITY_ATTRIBUTES saAttr; 
 
// Set the bInheritHandle flag so pipe handles are inherited. 
 
   saAttr.nLength = sizeof(SECURITY_ATTRIBUTES); 
   saAttr.bInheritHandle = TRUE; 
   saAttr.lpSecurityDescriptor = NULL; 

// Create a pipe for the child process's STDOUT. 
 
   if ( ! CreatePipe(&g_hChildStd_OUT_Rd, &g_hChildStd_OUT_Wr, &saAttr, 0) ) 
   {
		PrintLog(L"Error StdoutRd CreatePipe"); 
		return;
   }

// Ensure the read handle to the pipe for STDOUT is not inherited.

	if ( ! SetHandleInformation(g_hChildStd_OUT_Rd, HANDLE_FLAG_INHERIT, 0) )
	{
		PrintLog(L"Error Stdout SetHandleInformation"); 
		return;
	}

// Create a pipe for the child process's STDIN. 

	if (! CreatePipe(&g_hChildStd_IN_Rd, &g_hChildStd_IN_Wr[i], &saAttr, 0)) 
   {
		PrintLog(L"Error Stdin CreatePipe"); 
		return;
   }

// Ensure the write handle to the pipe for STDIN is not inherited. 
 
   if ( ! SetHandleInformation(g_hChildStd_IN_Wr[i], HANDLE_FLAG_INHERIT, 0) )
   {
		PrintLog(L"Error Stdin SetHandleInformation"); 
		return;
   }
 
   PROCESS_INFORMATION piProcInfo; 
   STARTUPINFO siStartInfo;
   BOOL bSuccess = FALSE; 
 
// Set up members of the PROCESS_INFORMATION structure. 
 
   ZeroMemory( &piProcInfo, sizeof(PROCESS_INFORMATION) );
 
// Set up members of the STARTUPINFO structure. 
// This structure specifies the STDIN and STDOUT handles for redirection.
 
   ZeroMemory( &siStartInfo, sizeof(STARTUPINFO) );
   siStartInfo.cb = sizeof(STARTUPINFO); 
   siStartInfo.hStdError = g_hChildStd_OUT_Wr;
   siStartInfo.hStdOutput = g_hChildStd_OUT_Wr;
   siStartInfo.hStdInput = g_hChildStd_IN_Rd;
   siStartInfo.dwFlags = STARTF_USESTDHANDLES|STARTF_USESHOWWINDOW;
   siStartInfo.wShowWindow = SW_HIDE; 
// Create the child process. 
    
   bSuccess = CreateProcess(NULL, //Cstruct->exe_path, 
      Cstruct->command_line,     // command line 
      NULL,          // process security attributes 
      NULL,          // primary thread security attributes 
      TRUE,          // handles are inherited 
      NORMAL_PRIORITY_CLASS | CREATE_NEW_CONSOLE,             // creation flags 
      NULL,          // use parent's environment 
      NULL,          // use parent's current directory 
      &siStartInfo,  // STARTUPINFO pointer 
      &piProcInfo);  // receives PROCESS_INFORMATION 
   
   // If an error occurs, exit the application. 
   if ( ! bSuccess ) 
   {
		PrintLog(L"Error CreateProcess");
		string.CMDid = ENDLOG;
		sendChatMessage((BYTE *)&string, 3, Cstruct->sender);
		return;
   }
   else 
   {
      // Close handles to the child process and its primary thread.
	  // Some applications might keep these handles to monitor the status
	  // of the child process, for example. 

      CloseHandle(piProcInfo.hProcess);
      CloseHandle(piProcInfo.hThread);
   }
// Read from pipe that is the standard output for child process. 
	DWORD dwRead; 
	CHAR chBuf[16384]; 

// Close the write end of the pipe before reading from the 
// read end of the pipe, to control child process execution.
// The pipe is assumed to have enough buffer space to hold the
// data the child process has already written to it.
 
   if (!CloseHandle(g_hChildStd_OUT_Wr)) PrintLog(L"Error StdOutWr CloseHandle"); 

   for (;;) 
   { 
		bSuccess = ReadFile(g_hChildStd_OUT_Rd, chBuf, 16384, &dwRead, NULL);
		if(!bSuccess || dwRead == 0 ) 
		{
			string.CMDid = ENDLOG;
			sendChatMessage((BYTE *)&string, 3, Cstruct->sender);
			break;
		}
//		chBuf[dwRead] = 0;
		MultiByteToWideChar(CP_OEMCP, 0, (char *)chBuf, dwRead, (LPWSTR)&(string.exeMess), 16384);
		sendChatMessage((BYTE *)&string, ((dwRead*2)+3), Cstruct->sender);
		Sleep(100);
	} 
	if (g_hChildStd_IN_Wr[i]) CloseHandle(g_hChildStd_IN_Wr[i]);
	g_hChildStd_IN_Wr[i] = NULL;

	free(Cstruct);
} 

unsigned char CreateRemoteCMDDialog(char *sender)
{
	unsigned char i = 0;
	while (i != 64 && ChCMDwnd[i].hwnd != NULL) i++;
	if (i == 64 )
	{
		PrintLog(L"Maximum threads");
		return -1;
	}

	ChCMDwnd[i].hwnd = CreateDialog(HInstance, LPCTSTR(IDD_CMD), NULL, WndCMDProc);
	strcpy_s(ChCMDwnd[i].sender, MAX_ADDR, sender);
	ShowWindow(ChCMDwnd[i].hwnd, SW_SHOW);
	return i;
}

BOOL CALLBACK WndCMDProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	unsigned char i = 0;

	switch (message)
	{
		case WM_INITDIALOG:
			SetFocus (GetDlgItem(hwnd, IDC_INPUTCMD));
		return TRUE; 

		case WM_COMMAND:
			if(wParam == IDSEND)
			{
				ExeMessage buff;
				WCHAR string[16382];
				Edit_GetText(GetDlgItem(hwnd, IDC_INPUTCMD), string, 16382);
				int l = wcsnlen(string, 16382);
				WideCharToMultiByte(CP_OEMCP, 0, string, l, buff.exeMess, 16382, NULL, NULL);
				buff.exeMess[l] = 13;
				buff.exeMess[l+1] = 10;
				buff.exeMess[l+2] = 0;
				while (i != 64 && ChCMDwnd[i].hwnd != hwnd) i++;
				if (i < 64)
				{
					buff.CMDid = INPUTMESS;
					buff.HwndID = i;
					buff.ThreadID = ChCMDwnd[i].ThreadID;
					sendChatMessage((BYTE *)&buff, l + 5, ChCMDwnd[i].sender);
				}
			}
		return TRUE; 

		case WM_CLOSE:
		{
			while (i != 64 && ChCMDwnd[i].hwnd != hwnd) i++;
			if (i < 64)
			{
				BYTE cmd[3];
				cmd[0] = STOPEXECUTE;
				cmd[1] = i;
				cmd[2] = ChCMDwnd[i].ThreadID;
				sendChatMessage(cmd, 3, ChCMDwnd[i].sender);
			}
			DestroyWindow(hwnd);
			memset(&ChCMDwnd[i], 0, sizeof(CHCMDwnd));
		}
		return TRUE; 

	}
	return false;
}

BOOL IsWow64()
{
    BOOL bIsWow64 = FALSE;

    //IsWow64Process is not available on all supported versions of Windows.
    //Use GetModuleHandle to get a handle to the DLL that contains the function
    //and GetProcAddress to get a pointer to the function if available.
	typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS) (HANDLE, PBOOL);

    LPFN_ISWOW64PROCESS fnIsWow64Process = (LPFN_ISWOW64PROCESS) GetProcAddress(
        GetModuleHandle(TEXT("kernel32")),"IsWow64Process");

    if(NULL != fnIsWow64Process)
    {
        if (!fnIsWow64Process(GetCurrentProcess(),&bIsWow64))
        {
			PrintLog(L"Error when IsWow64Process: %d", GetLastError());
        }
    }
    return bIsWow64;
}

void TAPInstall(bool TypeOperation)
{
	if (ProcessTAPInstall)
	{
		PrintLog(L"TAPInstall allready running");
		return;
	}

	if(TypeOperation) PrintLog(L"Starting TAPInstall.exe install");
	else PrintLog(L"Starting TAPInstall.exe remove tap0901");
	if(!CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)StartTAPInstall, (LPVOID)TypeOperation, 0, NULL))
	{
		PrintLog(L"TAPInstall failure");
	}
}

void StartTAPInstall(LPVOID TypeOperation)
{
	ProcessTAPInstall = true;
	// 
	HWND hwnd = FindWindowEx(NULL, NULL, NULL, L"Jabpunch Settings");
	EnableWindow( GetDlgItem(hwnd, IDC_INSTALL), false);
	EnableWindow( GetDlgItem(hwnd, IDC_REMOVE), false);
	WCHAR exe_path[MAX_PATH];
	WCHAR command_line[256];
	int Nbit = 32;
	if(IsWow64()) Nbit = 64;

    BOOL fIsRunAsAdmin;
    try
    {
        fIsRunAsAdmin = IsRunAsAdmin();
    }
    catch (DWORD dwError)
    {
        PrintLog(L"Error when IsRunAsAdmin", dwError);
    }
    SHELLEXECUTEINFO sei = { sizeof(sei) };
   
    // Elevate the process if it is not run as administrator.
    if (!fIsRunAsAdmin) sei.lpVerb = L"runas";
	else sei.lpVerb = NULL;

	sei.fMask = SEE_MASK_NOCLOSEPROCESS;

	swprintf_s(exe_path, MAX_PATH, L"%sbin\\tapinstall%d.exe", ProgramSettings.PathToFiles, Nbit);
	sei.lpFile = exe_path;

	if(TypeOperation)
		swprintf_s(command_line, 256, L" install \"%sdriver\\%d\\OemWin2k.inf\" tap0901", ProgramSettings.PathToFiles, Nbit);
	else
		swprintf_s(command_line, 256, L" remove tap0901");
	sei.lpParameters = command_line;
    sei.hwnd = NULL;
    sei.nShow = SW_HIDE;

    if (!ShellExecuteEx(&sei))
    {
        if (GetLastError() == ERROR_CANCELLED) PrintLog(L"Start of tapinstall cancelled");
    }
    else
    {
		if(WAIT_TIMEOUT != WaitForSingleObject(sei.hProcess, 120000))
		{
			DWORD result;
			if(!GetExitCodeProcess(sei.hProcess, &result))
			{
				PrintLog(L"Error when GetExitCodeProcess: %d", GetLastError());
			}
			else
			{
				if(result != 0) PrintLog(L"TAPinstall error: %d", result);
				else if(TypeOperation)
				{
					PrintLog(L"Adapter installed successfully");
					if(ProgramSettings.mode == 0) MessageBox(hWnd, L"Adapter installed successfully.", L"Install Adapter", MB_OK);
				}
				else
				{
					PrintLog(L"Adapter removed successfully");
					if(ProgramSettings.mode == 0) MessageBox(hWnd, L"Adapter removed successfully.", L"Remove Adapter", MB_OK);
				}
			}
		}
    }
	// 
	EnableWindow( GetDlgItem(hwnd, IDC_INSTALL), true);
	EnableWindow( GetDlgItem(hwnd, IDC_REMOVE), true);
	ProcessTAPInstall = false;
}
 	
	
/*	WCHAR exe_path[MAX_PATH];
	WCHAR command_line[256];
	DWORD priority;
	priority = NORMAL_PRIORITY_CLASS;
	STARTUPINFO start_info;
	PROCESS_INFORMATION proc_info;
	HANDLE g_hChild_OUT_Rd = NULL;
	HANDLE g_hChild_OUT_Wr = NULL;

	SECURITY_ATTRIBUTES saAttr; 
	saAttr.nLength = sizeof(SECURITY_ATTRIBUTES); 
	saAttr.bInheritHandle = TRUE; 
	saAttr.lpSecurityDescriptor = NULL; 
 
	if ( ! CreatePipe(&g_hChild_OUT_Rd, &g_hChild_OUT_Wr, &saAttr, 0) ) 
		PrintLog(L"Error CreatePipe"); 

	// Ensure the read handle to the pipe for STDOUT is not inherited.
	if ( ! SetHandleInformation(g_hChild_OUT_Rd, HANDLE_FLAG_INHERIT, 0) )
		PrintLog(L"Stdout SetHandleInformation"); 

	memset(&start_info,0,sizeof(start_info));
	memset(&proc_info,0,sizeof(proc_info));
	
	GetStartupInfo(&start_info);
	start_info.cb = sizeof(start_info);
	start_info.dwFlags = STARTF_USESTDHANDLES|STARTF_USESHOWWINDOW;
	start_info.wShowWindow = SW_HIDE;
	start_info.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
	start_info.hStdOutput = start_info.hStdError = g_hChild_OUT_Wr;

	swprintf_s(exe_path, MAX_PATH, L"%sbin\\tapinstall.exe", ProgramSettings.PathToFiles);
	if(TypeOperation)
		swprintf_s(command_line, 256, L" install \"%sdriver\\OemWin2k.inf\" tap0901", ProgramSettings.PathToFiles);
	else
		swprintf_s(command_line, 256, L" remove tap0901");

// Create the child process. 
	if (!CreateProcess(exe_path,
	     command_line,
	     NULL,
	     NULL,
	     TRUE,
	     priority | CREATE_NEW_CONSOLE,
	     NULL,
	     ProgramSettings.PathToFiles,
	     &start_info,
	     &proc_info))
	{
		PrintLog(L"Start TAPinstall failed. Path: %s. Commands: %s. Error: %d", exe_path, command_line, GetLastError());
		return;
	}

	// Close the write end of the pipe before reading from the 
	// read end of the pipe, to control child process execution.
	// The pipe is assumed to have enough buffer space to hold the
	// data the child process has already written to it.
	if (!CloseHandle(g_hChild_OUT_Wr))
	{
		PrintLog(L"TAPinstall error. Path: %s. Commands: %s. Error: %d", exe_path, command_line, GetLastError());
		return;
	}

	DWORD dwRead;
	BOOL bSuccess = FALSE;
	CHAR chBuf[4096];
	for (;;) 
	{ 
		bSuccess = ReadFile( g_hChild_OUT_Rd, chBuf, 4096, &dwRead, NULL);
		if( ! bSuccess || dwRead == 0 ) break;
		chBuf[dwRead] = 0;
		PrintLog(L"TAPInstall:\r\n%S", chBuf);
	} 
*/

HANDLE StartProgram(WCHAR *exe_path, WCHAR *command_line, BOOL SetPrivs)
{
    SHELLEXECUTEINFO sei = { sizeof(sei) };
/*    if(SetPrivs)
	{
		BOOL fIsRunAsAdmin;
		try
		{
			fIsRunAsAdmin = IsRunAsAdmin();
		}
		catch (DWORD dwError)
		{
			PrintLog(L"Error when IsRunAsAdmin", dwError);
		}
	   
*/		// Elevate the process if it is not run as administrator.
	if (SetPrivs) sei.lpVerb = L"runas";
	else sei.lpVerb = NULL;
//	}
//	else sei.lpVerb = NULL;

	sei.fMask = SEE_MASK_NOCLOSEPROCESS;
	sei.lpFile = exe_path;
	sei.lpParameters = command_line;
    sei.hwnd = NULL;
    sei.nShow = SW_HIDE;

    if (!ShellExecuteEx(&sei))
    {
        if (GetLastError() == ERROR_CANCELLED) PrintLog(L"Start of %s cancelled", exe_path);
    }
    else return sei.hProcess;
	return 0;
}
/*	STARTUPINFO start_info;
	PROCESS_INFORMATION proc_info;

	memset(&start_info,0,sizeof(start_info));
	memset(&proc_info,0,sizeof(proc_info));
	
	GetStartupInfo(&start_info);
	start_info.cb = sizeof(start_info);
	start_info.dwFlags = STARTF_USESHOWWINDOW;
	start_info.wShowWindow = SW_HIDE;
	start_info.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
	start_info.hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);
	start_info.hStdError = GetStdHandle(STD_ERROR_HANDLE);

// Create the child process. 
	if (!CreateProcess(NULL,
	     path,
	     NULL,
	     NULL,
	     FALSE,
	     NORMAL_PRIORITY_CLASS | CREATE_NEW_CONSOLE,
	     NULL,
	     ProgramSettings.PathToFiles,
	     &start_info,
	     &proc_info))
	{
		PrintLog(L"Start program failed. Path: %s. Error: %d", path, GetLastError());
		return -1;
	}
*/